searchNodes=[{"doc":"Documentation for LivebookHelpers .","ref":"LivebookHelpers.html","title":"LivebookHelpers","type":"module"},{"doc":"","ref":"LivebookHelpers.html#elixir_cells/1","title":"LivebookHelpers.elixir_cells/1","type":"function"},{"doc":"Takes a module and a path to a file, creates a livebook from the moduledocs in the given module. The .livemd extension is automatically added. Returns the file path for the created livebook. This function will take a module and turn the module doc found there into a livebook. This make it really easy to create one set of information and have it be represented in different formats. For example you can write a README, use it as the moduledoc then run this function to spit out a livebook with all the same info. Below is a summary of what we do to create the Livebook: The module is used as the title for the Livebook. Each function's @doc is put under a section with the function's name and arity. doctests become (formatted) elixir cells The magic line to make github render livebooks as markdown is added. Examples mix create_livebook_from_module LivebookHelpers &quot;my_livebook&quot;","ref":"LivebookHelpers.html#livebook_from_module/2","title":"LivebookHelpers.livebook_from_module/2","type":"function"},{"doc":"Takes a module and a path to a file, creates a livebook from the moduledocs in the given module. The .livemd extension is automatically added. The provided deps are put into a Mix.install section at the start of the livebook, so the deps should be in the format that Mix.install allows. This function will take a module and turn the module doc found there into a livebook. This make it really easy to create one set of information and have it be represented in different formats. For example you can write a README, use it as the moduledoc then run this function to spit out a livebook with all the same info. Below is a summary of what we do to create the Livebook: The module is used as the title for the Livebook. Each function's @doc is put under a section with the function's name and arity. doctests become (formatted) elixir cells The magic line to make github render livebooks as markdown is added. Examples mix create_livebook_from_module LivebookHelpers &quot;my_livebook&quot; &quot;[livebook_helpers: &quot;&gt;= 0.0.0&quot;]&quot;","ref":"LivebookHelpers.html#livebook_from_module/3","title":"LivebookHelpers.livebook_from_module/3","type":"function"},{"doc":"","ref":"LivebookHelpers.html#livebook_string/1","title":"LivebookHelpers.livebook_string/1","type":"function"},{"doc":"Returns the text that can be used to create a livebook using the docs in the supplied module.","ref":"LivebookHelpers.html#livebook_string/2","title":"LivebookHelpers.livebook_string/2","type":"function"},{"doc":"","ref":"LivebookHelpers.html#parse_bullet_point/3","title":"LivebookHelpers.parse_bullet_point/3","type":"function"},{"doc":"","ref":"LivebookHelpers.html#parse_doctest/2","title":"LivebookHelpers.parse_doctest/2","type":"function"},{"doc":"","ref":"LivebookHelpers.html#parse_elixir_cells/2","title":"LivebookHelpers.parse_elixir_cells/2","type":"function"},{"doc":"","ref":"LivebookHelpers.html#parse_four_space_code_blocks/2","title":"LivebookHelpers.parse_four_space_code_blocks/2","type":"function"},{"doc":"","ref":"LivebookHelpers.html#parse_module_doc/1","title":"LivebookHelpers.parse_module_doc/1","type":"function"},{"doc":"","ref":"LivebookHelpers.html#process_function_docs/2","title":"LivebookHelpers.process_function_docs/2","type":"function"},{"doc":"Takes a module and a path to a file creates a livebook from the moduledocs in the given module. The .livemd extension is automatically added. If any deps are provided then a section at the start will be created that will Mix.install all deps. This function will take a module and turn the module doc found there into a livebook. This make it really easy to create one set of information and have it be represented in different formats. For example you can write a README, use it as the moduledoc then run this function to spit out a livebook with all the same info. Below is a summary of what we do to create the Livebook: The module is used as the title for the Livebook. Each function's @doc is put under a section with the function's name and arity. doctests become (formatted) elixir cells The magic line to make github render livebooks as markdown is added. A section is placed at the start that will call Mix.install with any supplied deps. Examples mix create_livebook_from_module LivebookHelpers &quot;my_livebook&quot; With deps: mix create_livebook_from_module LivebookHelpers &quot;my_livebook&quot; &quot;[:livebook_helpers]&quot; mix create_livebook_from_module LivebookHelpers &quot;my_livebook&quot; &quot;[livebook_helpers: &quot; &gt;= 0.0 . 0 &quot;]&quot;","ref":"Mix.Tasks.CreateLivebookFromModule.html","title":"Mix.Tasks.CreateLivebookFromModule","type":"task"},{"doc":"Some useful helpers that you can use to interact with livebook.","ref":"readme.html","title":"LivebookHelpers","type":"extras"},{"doc":"The easiest way to use this is to include LivebookHelpers as a dev dependency: { :livebook_helpers , &quot;~&gt; 0.0.6&quot; , only : :dev } Now you can run the mix task as follows: mix CreateLivebookFromModule YourModule &quot;path_to_destination_livebook&quot; You can try it out with like this: mix CreateLivebookFromModule LivebookHelpers &quot;livebook_helpers_livebook&quot; Protocol Implementations When you implement a protocol a new module is created: defmodule Thing do defimpl Enum do ... end end This would create a module called Enum.Thing . If I were documenting all the functions in Thing , it would be great if it included any protocols that were implemented there also, but because a new module is created it's not trivial to do. We would have to find all protocols, then see if our module implemented any of them, then construct the module name and generate the docs for that module. I plan on trying this at some point. That means currently you will have to generate a livebook for each protocol implementation. You can find the name of the created module by doing this: defmodule Thing do defimpl Enum do __MODULE__ |&gt; IO . inspect ( limit : :infinity , label : &quot;protocol module name&quot; ) ... end end","ref":"readme.html#generating-livebooks-from-module-functions","title":"LivebookHelpers - Generating Livebooks From Module Functions.","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding livebook_helpers to your list of dependencies in mix.exs : def deps do [ { :livebook_helpers , &quot;~&gt; 0.0.7&quot; , only : :dev } ] end Contributing NB Set the MIX_ENV to :docs when publishing the package. This will ensure that modules inside test/support won't get their documentation published with the library (as they are included in the :dev env). MIX_ENV=docs mix hex.publish You will also have to set that env if you want to run mix docs MIX_ENV=docs mix docs Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/livebook_helpers .","ref":"readme.html#installation","title":"LivebookHelpers - Installation","type":"extras"}]